#ifndef	__PORTWELL_USETYPE__
#define	__PORTWELL_USETYPE__


// Return value definition
#define		NOERROR	                        0
#define		UNKNOWN_ERROR	                1
#define		DRIVER_NOT_FOUND	            2
#define		DRIVER_NOT_LOADED	            3
#define		DRIVER_NOT_LOADED_ON_NETWORK	4
#define		NOSUPPORTED_PLATFORM	        5
#define		INITIAL_ERROR					6
#define		INVALID_PARAMETER				7
#define		READ_ERROR						8
#define		WRITE_ERROR						9
#define		NOT_SUPPORT						10
#define		UNAVAILAVLE_SLEEP_TIME			11
#define		CANNOT_SET_IO_PERMISSION	    12
#define		CANNOT_SET_BACK_IO_PERMISSION	13
#define		NOT_READY						14
#define		UNAVAILABLE_SOUND				15
#define		DMI_GETMISS						16

//API releated value

//Temperature sensor read value define
typedef enum 
{
	TSENSOR_SYS1=0,
	TSENSOR_SYS2,
	TSENSOR_SYS3,
	TSENSOR_SYS4,
	SEC_TSENSOR_SYS1=0x100,
	SEC_TSENSOR_SYS2,
	SEC_TSENSOR_SYS3,
	SEC_TSENSOR_SYS4
} TEMPERATURE_SENSOR;

//Voltage read value define
typedef enum 
{
    VOL_VCORE, 
	VOL_VCCDDR,
	VOL_3P3V,
	VOL_VCC,
	VOL_12V,
	VOL_24V,
	VOL_VBAT,
	VOL_VTT,
    SEC_VOL_VCORE=0x100, 
	SEC_VOL_VCCDDR,
	SEC_VOL_3P3V,
	SEC_VOL_VCC,
	SEC_VOL_12V,
	SEC_VOL_24V,
	SEC_VOL_VBAT
} VOLTAGE_TYPE;

//Fan value define
typedef enum  
{
    CPUFAN,
    SYSFAN,
    AUXFAN,
    SEC_SYSFAN1=0x100,
    SEC_SYSFAN2,
    SEC_SYSFAN3
} FANTYPE;

typedef enum
{
	SECOND_MODE = 0,
	MINUTE_MODE
} WDT_TYPE;

typedef enum
{
	GPIO_OUTPUT,
	GPIO_INPUT,
} GPIO_TYPE;

typedef enum
{
	GPIO_LOW,
	GPIO_HIGH
} GPIO_RW;

typedef enum
{
    SM_WRITE,
    SM_READ,
} SMBUS_TYPE;


typedef enum
{
    BYTE_ADDR,
    WORD_ADDR,
} EC_IIC_ADDR_MODE;

typedef enum
{
    BYTE_DATA,
    WORD_DATA,
	LONG_DATA,

} EC_IIC_DATA_MODE;

typedef enum
{
   F400K,
   F100K,
   F50K,

} EC_FREQUENCY;

typedef struct 
{
    int tjMax;
	int maxFrequency;
	char vendorName[13];
	int steppingId;
	int familyId;
	int modeId;
	int typeId;

	char CacheL1[150];
	char CacheL2[150];
	char CacheL3[150];

	char cacheTlbInfo[15][150];
	int cacheTlbInfoLength;
	char features[64][150];
	int featuresLength;

	double (*getVoltage)();
	int (*getCurrentFrequency)();
    int (*getCpuTemperature)();

}CpuInfo;

#endif