#include "stdafx.h"
#include "User_Api.h"
#include "PET_Type.h"

#ifdef _M_X64
	#ifdef _DEBUG
		#pragma comment(lib, "../debug/x64/PETx64.lib")
	#else
		#pragma comment(lib, "../release/x64/PETx64.lib")
	#endif
#else 
	#ifdef _DEBUG
		#pragma comment(lib, "../debug/x86/PET.lib")
	#else
		#pragma comment(lib, "../release/x86/PET.lib")
	#endif
#endif

#define WDT_ACTION		0

#define	BOARD_INFO         1
#define	HWM_TEST           2
#define CPU_Info           3
#define EC_IIC_Word        4
#define EC_IIC_Byte_Write  5
#define EC_IIC_Byte_Read   6
#define EC_IIC_Quick       7
#define EC_IIC_Block      19
#define WDT_TEST           8
#define	GPIO_READ          9
#define	GPIO_WRITE        10
#define	GPIO_SETDIR       22
#define	TEST_GPIO_INPUT   11
#define	TEST_GPIO_INPUT2  12
#define	SMBUS_TEST        13
#define SMBUS_EEPROM_TEST 20
#define SMBUS_SCAN        21
#define	BLC_TEST          14
#define	BEEP_TEST         15
#define	NOTE_TEST         16
#define	EC_IIC_RWC        17
#define	CPU_FAN_TEST      18
#define	OPTION_MAX        23

int menuOPT(int *opt){
	char input[10];
	printf ("==== Portwell Inc ====\n");
	printf ("Test Menus:\n");
	printf("%2d)BOARD_INFO\n", BOARD_INFO);
	printf("%2d)HWM_TEST\n", HWM_TEST);
	printf("%2d)CPU_Info\n", CPU_Info);
	printf("%2d)EC_IIC_Word\n", EC_IIC_Word);
	printf("%2d)EC_IIC_Byte_Write\n", EC_IIC_Byte_Write);
	printf("%2d)EC_IIC_Byte_Read\n", EC_IIC_Byte_Read);
	printf("%2d)EC_IIC_Quick\n", EC_IIC_Quick);
	printf("%2d)EC_IIC_Block\n", EC_IIC_Block);	
	printf("%2d)WDT_TEST\n", WDT_TEST);
	printf("%2d)WDT_ACTION\n", WDT_ACTION);
	printf("%2d)GPIO_READ\n", GPIO_READ);
	printf("%2d)GPIO_WRITE\n",GPIO_WRITE);
	printf("%2d)GPIO_SETDIR\n",GPIO_SETDIR);
	printf("%2d)TEST_GPIO_INPUT\n", TEST_GPIO_INPUT);
	printf("%2d)TEST_GPIO_INPUT2\n", TEST_GPIO_INPUT2);
	printf("%2d)SMBUS_TEST\n", SMBUS_TEST);
	printf("%2d)SMBUS_SCAN\n", SMBUS_SCAN);
	printf("%2d)SMBUS_EEPROM_TEST\n", SMBUS_EEPROM_TEST);
#ifdef ECSMBUS_TEST
	printf("%2d)ECSMBUS_TEST\n", ECSMBUS_TEST);
#endif
	printf("%2d)BLC_TEST\n", BLC_TEST);
	printf("%2d)BEEP_TEST\n", BEEP_TEST);
	printf("%2d)NOTE_TEST\n", NOTE_TEST);
#ifdef IIC_TEST
	printf("%2d)IIC_TEST\n", IIC_TEST);
#endif
#ifdef EC_IIC_RWC
	printf("%2d)EC_IIC_RWC\n", EC_IIC_RWC);
#endif
	printf("%2d)CPU_FAN_TEST\n", CPU_FAN_TEST);
	printf("Please Enter Test option\n");
	fgets(input, 10, stdin);
	*opt = atoi(input);
	if(*opt == 0 && input[0] != '0')
		return 1;
	else if(*opt < 0 || *opt >= OPTION_MAX)
		return 1;
	else
		return NOERROR;
}

int testeciic(int rwc, char* addr, int base){
	unsigned char slave_addr = 0;
	unsigned char value = 0;
	unsigned char chkval = 0;
	int i, ret, chk = 0;
    FILE *fp;

	if(addr != NULL)	  
		slave_addr = (unsigned char)strtoul(addr, NULL, 16);
	else
		slave_addr =0xa0;
	printf("slave_addr=%#x\n", slave_addr);

	if(rwc == 1){
		fp=fopen("read.bin","w");
		if(fp==NULL){
			printf("open file error!!\n");
			return 1;
		} 
		for(i=0x00;i<=0xff;i++){
//		(unsigned char slave_addr,unsigned int offset,unsigned char *value,int length);
			ret = PET_EC_IIC_Byte_Addr_Read(slave_addr, i, &value, 1);
			if(ret != 0){
				printf("\nread %#x val=%#x failed\n", i, value);
				break;
			}
			fwrite(&value,1, sizeof(value), fp);
		}
		fclose(fp);
	}else if(rwc == 3){
		fp=fopen("write.bin","r");
		if(fp==NULL){
			printf("open file error!!\n");
			return 1;
		} 
		for(i=0x00;i<=0xff;i++){
//		(unsigned char slave_addr,unsigned int offset,unsigned char *value,int length);
			ret = PET_EC_IIC_Byte_Addr_Read(slave_addr, i, &value, 1);
			if(ret != 0){
				printf("\nread %#x val=%#x failed\n", i, value);
				break;
			}
			fread(&chkval,1, sizeof(chkval), fp);
			if(chkval != value){
				printf("\ncheck %#x val=%#x chkval=%#x failed\n", i, value, chkval);
				chk++;
			}
		}
		if (chk == 0)
			printf("Check eeprom %#x PASS!\n", slave_addr);
		fclose(fp);
	}else if(rwc == 2){
		fp=fopen("write.bin","w");
		if(fp==NULL){
			printf("open file error!!\n");
			return 1;
		} 
		for(i=0x00;i<=0xff;i++){
			value = (i+base)%0x100;
			ret = PET_EC_IIC_Byte_Addr_Write(slave_addr, i, &value, 1);
			if(ret != 0){
				printf("\nwrite %#x val=%#x failed\n", i, value);
				break;
			}
			fwrite(&value,1, sizeof(value), fp);
//			printf("write %#x val=%#x\n", i, value);
		}
		if (i == 0x100)
			printf("Write eeprom %#x PASS!\n", slave_addr);
		else
			chk = 1;
		fclose(fp);
	}
	return chk;
}

int main(int argc, char* argv[])
{
	int i, j, opt, gpio_set, gpio_pin;
	int ret, error_code = 1;
    char temp [50];
	unsigned char gpio_value, gpio_direction;
    double cputemp, systemp, voltage;
    int fan_value;
	int fan_ratio;

    int wdt_type = SECOND_MODE;
	unsigned char wdt_timeout = 10;
    unsigned char wdt_min, wdt_max;

	unsigned char slave_addr = 0xA0; //SPD
	//unsigned char slave_addr = 0xD2; //ClockGen
	unsigned char offset = 0x00;
	unsigned char smbus_value;
	unsigned char blc_ratio = 50; // set 50%

	//for ec iic function
	unsigned char slaveAddress=0xAE;
	int address=0x00;
	unsigned char value[32];
	unsigned char status=0;
	int length=0;		
	int iEnd=0;	
	unsigned char quick_value;
	unsigned int plat_ver;
#ifdef HWM_TEST
#define MAX_VOL_IDX 14
int vol_arr[MAX_VOL_IDX]={
    VOL_VCORE, 
	VOL_VCCDDR,
	VOL_3P3V,
	VOL_VCC,
	VOL_12V,
	VOL_24V,
	VOL_VBAT,
    SEC_VOL_VCORE, 
	SEC_VOL_VCCDDR,
	SEC_VOL_3P3V,
	SEC_VOL_VCC,
	SEC_VOL_12V,
	SEC_VOL_24V,
	SEC_VOL_VBAT	
};
char vol_str[MAX_VOL_IDX][20]={
    "CPU Vcore",
	"DDR Vcc",
	"EC 3.3V",
	"EC 5V",
	"EC 12V",
	"EC 24V",
	"EC Battery V",
    "EC2 CPU Vcore",
	"EC2 DDR Vcc",
	"EC2 3.3V",
	"EC2 5V",
	"EC2 12V",
	"EC2 24V",
	"EC2 Battery V"
};
#endif

#ifdef __linux__
	int sta;

	sta=seteuid(0);
	if(sta < 0)
    {
        printf ("error: seteuid failed.\n");
        printf ("Warning! PET need to access /dev/mem and ioport\n");
		printf("Please use \"sudo chown root:root TESTAP && sudo chmod +s TESTAP\" to allow access\n");
    }
	printf ("effective uid: %d\n", geteuid());
#endif	
	
	if(argc >= 2){
		opt = atoi(argv[1]);
		if((opt > 0 && opt < OPTION_MAX) || (opt == 0 && argv[1][0]=='0'))
			error_code = NOERROR;
	}else
		error_code = menuOPT(&opt);
	if(error_code != NOERROR){
		printf("Please input correct option!");
		return 1;
	}
	error_code = PET_API_Init();
	if (error_code != NOERROR)
	{
		if (error_code == NOSUPPORTED_PLATFORM)
			printf ("The PET API Library not support the board.\n");
		else
			printf("API init fail, error code = %d\n", error_code);
		PET_API_Uninit ();
		return 1;
	}

	
switch(opt){
case BOARD_INFO:
	error_code = PET_Board_GetPlatformName (temp); 
    if (error_code == NOERROR)
		printf ("Board name: %s\n", temp);
	else if (error_code == NOT_SUPPORT)
		printf ("The Board name function no support.\n");
	else
        printf ("Get board name error, error number %d\n", error_code);

	error_code = PET_Board_GetBIOSVersion (temp);
    if (error_code == NOERROR)
        printf ("PET Board BIOS Version: %s\n", temp);
	else if (error_code == NOT_SUPPORT)
		printf ("The Board BIOS function no support.\n");
	else
		printf ("Get BIOS version error, error number %d\n", error_code);
	error_code = PET_API_GetVersion (temp);
    if (error_code == NOERROR)
        printf ("PET API Version: %s\n", temp);
	else if (error_code == NOT_SUPPORT)
		printf ("The PET API function no support.\n");
	else
		printf ("Get API version error, error number %d\n", error_code);
	error_code = PET_Board_GetECVersion(temp);
    if (error_code == NOERROR)
        printf ("PET EC Version: %s\n", temp);
	else if (error_code == NOT_SUPPORT)
		printf ("The PET EC function no support.\n");
	else
		printf ("Get EC version error, error number %d\n", error_code);
	error_code = PET_Get_Platform_Version(&plat_ver);
    if (error_code == NOERROR)
        printf ("PET_Get_Platform_Version: %#x\n", plat_ver);
	else if (error_code == NOT_SUPPORT)
		printf ("The PET Platform Version function no support.\n");
	else
		printf ("Get Platform Version error, error number %d\n", error_code);
	
/*
	error_code = PET_API_SetIOSleepTime (10); // 10u second
    if (error_code == NOERROR)
        printf ("Set I/O sleep time is successful\n");
	else if (error_code == NOT_SUPPORT)
		printf ("The function no support.\n");
	else
		printf ("Set I/O sleep time error, error number %d\n", error_code);
*/
break;

case HWM_TEST:

	printf ("\n==== Hardware Monitor ====\n");

	error_code = PET_HWM_CPUTemperature (0, &cputemp);
	if (error_code == NOERROR)
        printf ("CPU temperature value is %3.2f\n", cputemp);
	else if (error_code == NOT_SUPPORT)
		printf ("The CPU temperature function no support.\n");
	else
        printf ("Get CPU temperature error, error number %d\n", error_code);
		
//	error_code = PET_HWM_SysTemperature (&systemp);
	error_code = PET_HWM_Temperature (TSENSOR_SYS1, &systemp);
	if (error_code == NOERROR)
        printf ("System temperature value is %3.2f\n", systemp);
	else if (error_code == NOT_SUPPORT)
		printf ("The System temperature function no support.\n");
	else
        printf ("Get System temperature error, error number %d\n", error_code);
	error_code = PET_HWM_Temperature (TSENSOR_SYS2, &systemp);
	if (error_code == NOERROR)
        printf ("System temperature value is %3.2f\n", systemp);
	else if (error_code != NOT_SUPPORT)
        printf ("Get System temperature error, error number %d\n", error_code);
	error_code = PET_HWM_Temperature (TSENSOR_SYS3, &systemp);
	if (error_code == NOERROR)
        printf ("System temperature value is %3.2f\n", systemp);
	else if (error_code != NOT_SUPPORT)
        printf ("Get System temperature error, error number %d\n", error_code);

	for(i=0;i<MAX_VOL_IDX;i++){
		error_code = PET_HWM_Voltage (vol_arr[i], &voltage);
		if (error_code == NOERROR)
			printf ("%s value is %3.3f (V)\n", vol_str[i], voltage);
		else if (error_code == NOT_SUPPORT)
			printf ("The %s function no support.\n", vol_str[i]);
		else
			printf ("Get %s value error, error number %d\n",vol_str[i], error_code);
	}

	error_code = PET_HWM_GetFanSpeed (CPUFAN, &fan_value);
	if (error_code == NOERROR)
		printf ("CPU fan speed: %d\n", fan_value);
	else if (error_code == NOT_SUPPORT)
		printf ("CPU fan speed function no support.\n");
	else
        printf ("Get CPU fan speed error, error number %d\n", error_code); 

    error_code = PET_HWM_GetFanSpeed (SYSFAN, &fan_value);
    if (error_code == NOERROR)
		printf ("System fan speed: %d\n", fan_value);
	else if (error_code == NOT_SUPPORT)
		printf ("System fan speed function no support.\n");
	else
        printf ("Get System fan speed error, error number %d\n", error_code);

    error_code = PET_HWM_GetFanSpeed (AUXFAN, &fan_value);
    if (error_code == NOERROR)
		printf ("AUX fan speed: %d\n", fan_value);
	else if (error_code == NOT_SUPPORT)
		printf ("AUX fan speed function no support.\n");
	else
        printf ("Get AUX fan speed error, error number %d\n", error_code);
break;
case CPU_FAN_TEST:
	i=0;
	do{
		printf("1)Set Fan Speed\n");
		printf("2)Get Fan Speed\n");
		printf("3)End Test\n");
		value[0]=fgetc(stdin);
		value[1]=fgetc(stdin);
		if(value[1]!='\n'){
			printf("Incorrect input\n");
			continue;
		}
		i=atoi((char*)value);
		if(i==2){
			error_code = PET_HWM_GetFanSpeed (CPUFAN, &fan_value);
			if (error_code == NOERROR)
				printf ("CPU fan speed: %d\n", fan_value);
			else if (error_code == NOT_SUPPORT)
				printf ("CPU fan speed function no support.\n");
			else
				printf ("Get CPU fan speed error, error number %d\n", error_code);
		}else if(i==1){
			printf("Please input Fan speed ration(0-100):\n");
			for(j=0;j<4;j++)
				value[j]=fgetc(stdin);
			if(value[j-1]!='\n'){
				printf("Incorrect input\n");
				continue;
			}
			fan_ratio = atoi((char*)value);
			if(fan_ratio < 0 || fan_ratio >100){
				printf("Incorrect input\n");
				continue;
			}
			error_code = PET_HWM_SetFanSpeed (CPUFAN, fan_ratio);
			if (error_code == NOERROR)
				printf ("Set CPU fan speed ratio: %d%%\n", fan_ratio);
			else if (error_code == NOT_SUPPORT)
				printf ("Set CPU fan speed function no support.\n");
			else
				printf ("Set CPU fan speed error, error number %d\n", error_code);
		}
	}while(i==1 || i==2);
break;
case CPU_Info:
	printf ("\n==== Cpu Information ====\n");
	CpuInfo cpu;
	PET_New_CPU_Obj(&cpu);			
	//static
	printf("Vendor:%s\n",cpu.vendorName);
	printf("Family:%X\n",cpu.familyId);
	printf("Model:%X\n",cpu.modeId);
	printf("Stepping:%X\n",cpu.steppingId);
	printf("Type:%X\n",cpu.typeId);
	printf("TjMax:%d\n",cpu.tjMax);	
	//printf("MaxFrequency:%dMHz\n",cpu.maxFrequency);

	printf("-----------------Cache Size Info--------------------\n");
	printf("%s\n",cpu.CacheL1);
	printf("%s\n",cpu.CacheL2);
	printf("%s\n",cpu.CacheL3);

	printf("-----------------Cache TLB Info--------------------\n");	
	for(i=0;i<cpu.cacheTlbInfoLength;i++)
	{
		printf("%d:",(i+1));
		printf("%s\n",cpu.cacheTlbInfo[i]);
	}

	printf("-----------------Cpu Feature--------------------\n");
	for(i=0;i<cpu.featuresLength;i++)
	{
		printf("%d:",(i+1));
		printf("%s\n",cpu.features[i]);		
	}


	printf("-------------------------------------\n");
	printf("Cpu Temperature:%d\n",cpu.getCpuTemperature());
	printf("CurrentFrequency:%d\n",cpu.getCurrentFrequency());
	printf("Voltage:%f\n",cpu.getVoltage());
	printf("-------------------------------------\n");
break;

case EC_IIC_Word:
	printf ("\n====EC IIC Test====\n");
	printf("-------------------Word Address--------------------\n");
	printf("-----------------------Write-----------------------\n");
	address=0x00;
	length=8;
	iEnd=512/length;

	for(i=0;i<length;i++)
		value[i]=i;		

	for(i=0;i<iEnd;i++)
	{
		error_code=PET_EC_IIC_Word_Addr_Write(slaveAddress,address,value,length);
		if(error_code==0)
		{
			printf("Write:");
			for(j=0;j<length;j++)
			{				
				printf("%X,",value[j]);
				value[j]+=length;				
			}
			printf("to %X\n",address);
			address+=length;
		}else
		{
			printf("Write Error\n");
			break;
		}

	}
	
	printf("-------------------Word Address--------------------\n");
	printf("-----------------------Read-----------------------\n");

	length=8;	
	address=0x00;	
	for(i=0;i<iEnd;i++)
	{				
		error_code=PET_EC_IIC_Word_Addr_Read(slaveAddress,address,value,length);
		if(error_code==0)
		{
			printf("Read:");
			for(j=0;j<length;j++)
			{
				printf("%X,",value[j]);				
			}
			printf("from %X\n",address);
			address+=length;
		}else
		{
			printf("Read Error\n");
			break;
		}	
	}	
	printf("---------------------------------------------------\n");
break;

case EC_IIC_Byte_Write:
	printf ("\n====EC IIC Test====\n");
	
	printf("-------------------Byte Address--------------------\n");
	printf("-----------------------Write-----------------------\n");
	do{
		printf("Please input target i2c device address(8 bits):\n");
	}while(scanf("%hhx", &slaveAddress)!=1);
	do{
		printf("Please input write data offset:\n");
	}while(scanf("%x", &address)!=1);
	do{
		printf("Please input write data value:\n");
	}while(scanf("%hhx", &value)!=1);
	error_code=PET_EC_IIC_Byte_Addr_Write(slaveAddress,address,value,1);
	if(error_code==0)
		printf("I2C device %#x, offset %#x, write data %#x PASS\n", slaveAddress, address, value[0]);
	else
		printf("I2C device %#x, offset %#x, write data %#x FAIL\n", slaveAddress, address, value[0]);
break;
case EC_IIC_Byte_Read:
	printf("-------------------Byte Address--------------------\n");
	printf("-----------------------Read-----------------------\n");
	do{
		printf("Please input target i2c device address(8 bits):\n");
	}while(scanf("%hhx", &slaveAddress)!=1);
	do{
		printf("Please input read data offset:\n");
	}while(scanf("%x", &address)!=1);
		value[0]=0xff;
		error_code=PET_EC_IIC_Byte_Addr_Read(slaveAddress,address,value,1);
		if(error_code==0)
			printf("I2C device %#x, offset %#x, Read data %#x PASS\n", slaveAddress, address, value[0]);
		else
			printf("I2C device %#x, offset %#x, Read data  Error(%#x), val=%#x\n", slaveAddress, address, error_code, value[0]);
break;

case EC_IIC_Quick:
	printf ("\n====EC IIC Quick Read/Write Test====\n");
	printf("-------------------Byte Address--------------------\n");
	printf("-----------------------Write-----------------------\n");
	do{
		printf("Please input target i2c device address(8 bits):\n");
	}while(scanf("%hhx", &slaveAddress)!=1);
	do{
		printf("Please input write data offset:\n");
	}while(scanf("%hhx", &quick_value)!=1);

	error_code=PET_EC_IIC_Quick_Write(slaveAddress, (unsigned int)quick_value);
	if(error_code==0)
		printf("I2C device %#x, write data %#x PASS\n", slaveAddress, quick_value);
	else
		printf("I2C device %#x, write data %#x Error\n", slaveAddress, quick_value);
	
	printf("-------------------Byte Address--------------------\n");
	printf("-----------------------Read-----------------------\n");
	do{
		printf("Please input target i2c device address(8 bits):\n");
	}while(scanf("%hhx", &slaveAddress)!=1);
	do{
		printf("Please input read data offset:\n");
	}while(scanf("%x", &address)!=1);
		error_code=PET_EC_IIC_Quick_Read(slaveAddress,address,&quick_value);
		if(error_code==0)
			printf("I2C device %#x, offset %#x, Read data %#x PASS\n", slaveAddress, address, quick_value);
		else
			printf("I2C device %#x, offset %#x, Read data %#x Error\n", slaveAddress, address, quick_value);
	printf("---------------------------------------------------\n");
break;
case EC_IIC_Block:
	length=8;  //Max page size of AT24C02D is 8 bytes
	iEnd=256;
	printf ("\n====EC IIC Test====\n");
	do{
		printf("Please input target i2c device address(8 bits):\n");
	}while(scanf("%hhx", &slaveAddress)!=1);

	printf("-------------------Block Write--------------------\n");
	for(i=0;i<length;i++)
		value[i]=i;
	for(address=0;address<iEnd;address+=length){
		error_code=PET_EC_IIC_Byte_Addr_Write(slaveAddress, address, value, length);
		if(error_code==0){
			printf("Write:");
			for(j=0;j<length;j++){				
				printf("%02X,",value[j]);
				value[j]+=length;				
			}
			printf("to %02X\n",address);
		}else{
			printf("Write Error\n");
			break;
		}
	}
	
	printf("-----------------------Block Read-----------------------\n");
	for(address=0;address<iEnd;address+=length)
	{
		for(j=0;j<length;j++)value[j]=0;
		error_code=PET_EC_IIC_Byte_Addr_Read(slaveAddress, address, value, length);
		if(error_code==0)
		{
			printf("Read:");
			for(j=0;j<length;j++)
				printf("%02X,",value[j]);				
			printf("from %02X\n",address);
		}else{
			printf("Read Error\n");
			break;
		}	
	}	
	printf("---------------------------------------------------\n");
	printf("-----------------------Byte Read-----------------------\n");
	address=0x00;	
	for(address=0;address<iEnd;address++)
	{				
		error_code=PET_EC_IIC_Byte_Addr_Read(slaveAddress,address,value,1);
		if(error_code==0)
		{
			if(address%length==0)printf("Read:");
				printf("%02X,",value[0]);				
			if(address%length==(length-1))printf("from %02X\n",address-length+1);
		}else
		{
			printf("Read Error\n");
			break;
		}	
	}	
	printf("---------------------------------------------------\n");
break;
case WDT_TEST:

	printf ("\n==== Test WDT Function ====\n");
	error_code = PET_WDT_GetRange (SECOND_MODE, &wdt_min, &wdt_max);
	if (error_code == NOERROR)
    	printf ("The WDT seconde mode range: %d ~ %d (sec)\n", wdt_min, wdt_max);
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT range function no support.\n");
	else
		printf ("Get WDT range error, error number %d\n", error_code);

	// wdt type: 0 is second mode, 1 is minute mode
	error_code = PET_WDT_SetConfig (wdt_type, wdt_timeout);
	if (error_code == NOERROR)
		printf ("WDT setting is successful.\n");
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT setting function no support.\n");
	else
		printf ("WDT setting error, error code %d\n", error_code);

	error_code = PET_WDT_GetConfig (&wdt_type, &wdt_timeout);
	if (error_code == NOERROR)
        printf ("WDT type:%d, timeout:%d\n", wdt_type, wdt_timeout);
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT get config function no support.\n");
	else
		printf ("The WDT get config error, error code %d\n", error_code);

    error_code = PET_WDT_Trigger ();
	if (error_code == NOERROR)
        printf ("WDT Trigger NOW !!\n");
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT trigger function no support.\n");
	else
		printf ("The WDT trigger error, error code %d\n", error_code);

	error_code = PET_WDT_Available ();
	if (error_code == NOERROR)
   		printf ("WDT trigger is available.\n");
	else if (error_code == NOT_READY)
	    printf ("The WDT is not Ready.\n");
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT available function no support.\n");
	else
		printf ("The WDT available error, error code %d\n", error_code);

    #if WDT_ACTION
        while(1)
        {
            printf ("Reset counter ......%d\n", wdt_timeout - i);
			error_code = PET_WDT_Trigger ();
            Sleep (wdt_timeout-2);
		}	
    #else
		printf ("If you want to test WDT reset function, Please press Ctrl+C to force wdt_trigger stop before count end.\n");
        for (i = 1; i <= wdt_timeout; i++)
        {
            printf ("Reset counter ......%d\n", wdt_timeout - i);
			error_code = PET_WDT_Trigger();
            Sleep (1000);
        }
		PET_WDT_Disable();
		printf("WDT is disabled!\n");
#endif

break;
case GPIO_SETDIR:
	do{
		printf("Please input target GPIO set:\n");
	}while(scanf("%d", &gpio_set)!=1);
	do{
		printf("Please input target GPIO pin:\n");
	}while(scanf("%d", &gpio_pin)!=1);
	do{
		printf("Please input target GPIO Direction(1:Iuput, 0:Output):\n");
	}while(scanf("%d", &gpio_direction)!=1);
	if(gpio_direction!=0&&gpio_direction!=1){
		printf("Invalid Input!");
		break;
	}
	ret = PET_GPIO_SetPinDirection (gpio_set, gpio_pin, gpio_direction); 
	if (ret != NOERROR) {
		printf(" PET_GPIO_SetPinDirection(%d,%d,%d) failed %d\n", gpio_set, gpio_pin, gpio_direction, ret);
		break;
	}else
		printf("Set gpio group %d pin %d to %s mode\n", gpio_set, gpio_pin, gpio_direction==0?"output":"input");
break;
case GPIO_WRITE:
	if (argc == 5) {
		printf("GPIO pin write test:\n");
		gpio_set = atoi(argv[2]);
		gpio_pin = atoi(argv[3]);
		gpio_value = atoi(argv[4]);
		if (gpio_set < 1 || gpio_pin > 9) {
			printf("Error!Incorrect gpio_set!\n");
			break;
		}
		if (gpio_pin < 1 || gpio_pin > 8) {
			printf("Error!Incorrect gpio_pin!\n");
			break;
		}
		if (argv[4][0] != '1' && argv[4][0] != '0') {
			printf("Error!Incorrect gpio_value!\n");
			break;
		}
		printf("Warning: This operation may change gpio direction config!\n");
#ifndef __linux__
		system ("pause");
#else
		printf("Press Enter key to continue...\n");  
		fgetc(stdin); 
#endif
		ret = PET_GPIO_SetPinDirection (gpio_set, gpio_pin, 0); 
		if (ret != NOERROR) {
			printf(" PET_GPIO_SetPinDirection(%d,%d) failed %d\n", gpio_set, gpio_pin, ret);
			break;
		}else
			printf("Set gpio group %d pin %d to output mode\n", gpio_value, gpio_set, gpio_pin);
		printf("write %d to gpio group %d pin %d\n", gpio_value, gpio_set, gpio_pin);
		ret = PET_GPIO_ReadPinDirection(gpio_set, gpio_pin, &gpio_direction);
		if (ret != NOERROR) {
			printf(" PET_GPIO_ReadPinDirection(%d,%d) failed %d\n", gpio_set, gpio_pin, ret);
			break;
		}
		if (gpio_direction != 0) {
			printf(" Error! GPIO(%d,%d) is not OUTPUT mode!\n", gpio_set, gpio_pin);
			break;
		}
		ret = PET_GPIO_WritePin(gpio_set, gpio_pin, gpio_value);
		if (ret != NOERROR)
			printf(" PET_GPIO_WritePin(%d,%d,%d) failed %d\n", gpio_set, gpio_pin, gpio_value, ret);
		else {
			ret = PET_GPIO_Read(gpio_set, &gpio_value);
			printf("GPIO PINS  1 2 3 4 5 6 7 8\n");
			printf("GPIO Data: %d %d %d %d %d %d %d %d\n",
				(gpio_value & 0x01) == 0 ? 0 : 1,
				(gpio_value & 0x02) == 0 ? 0 : 1,
				(gpio_value & 0x04) == 0 ? 0 : 1,
				(gpio_value & 0x08) == 0 ? 0 : 1,
				(gpio_value & 0x10) == 0 ? 0 : 1,
				(gpio_value & 0x20) == 0 ? 0 : 1,
				(gpio_value & 0x40) == 0 ? 0 : 1,
				(gpio_value & 0x80) == 0 ? 0 : 1);
		}
	}
	else {
		if(argc == 3){
			gpio_set = atoi(argv[2]);
			i=gpio_set;
		}else if(argc > 3){
			printf("GPIO write command:\n");
			printf("TESTAP %d <gpio_set> [<gpio_pin> <gpio_value>]\n", GPIO_WRITE);
			break;
		}else{
			gpio_set=0;
			printf("GPIO group %d write test:\n", gpio_set);
			ret = PET_GPIO_TotalSet(&gpio_set);
			if(ret == 0)
				printf(" Number of GPIO Groups: %d\n", gpio_set);
			else
				printf(" Number of GPIO Groups: Not Support\n");
			i=1;
		}
		for(;i<=gpio_set;i++){
			printf("Write GPIO set %d to High:\n", i);
#ifndef __linux__
		system ("pause");
#else
		printf("Press Enter key to continue...\n");  
		fgetc(stdin); 
#endif
			ret = PET_GPIO_TotalNumber(i, &gpio_pin);
			ret = PET_GPIO_ReadDirection(i, &gpio_direction);
			ret = PET_GPIO_Write(i, 0xff);
			if (ret != NOERROR)
				printf(" PET_GPIO_Write(%d) failed %d\n", i, ret);
			else
				printf(" PET_GPIO_Write group %d to 1\n", i);
			printf(" GPIO PINS     : 1 2 3 4 5 6 7 8\n");
			printf(" GPIO Direction: %c %c %c %c %c %c %c %c\n", 
				gpio_pin>0?((gpio_direction&0x01)==0?'O':'I'):'X',
				gpio_pin>1?((gpio_direction&0x02)==0?'O':'I'):'X',
				gpio_pin>2?((gpio_direction&0x04)==0?'O':'I'):'X',
				gpio_pin>3?((gpio_direction&0x08)==0?'O':'I'):'X',
				gpio_pin>4?((gpio_direction&0x10)==0?'O':'I'):'X',
				gpio_pin>5?((gpio_direction&0x20)==0?'O':'I'):'X',
				gpio_pin>6?((gpio_direction&0x40)==0?'O':'I'):'X',
				gpio_pin>7?((gpio_direction&0x80)==0?'O':'I'):'X');
			ret = PET_GPIO_Read(i, &gpio_value);
			printf(" GPIO Data     : %c %c %c %c %c %c %c %c\n", 
				gpio_pin>0?((gpio_value&0x01)==0?'0':'1'):'X',
				gpio_pin>1?((gpio_value&0x02)==0?'0':'1'):'X',
				gpio_pin>2?((gpio_value&0x04)==0?'0':'1'):'X',
				gpio_pin>3?((gpio_value&0x08)==0?'0':'1'):'X',
				gpio_pin>4?((gpio_value&0x10)==0?'0':'1'):'X',
				gpio_pin>5?((gpio_value&0x20)==0?'0':'1'):'X',
				gpio_pin>6?((gpio_value&0x40)==0?'0':'1'):'X',
				gpio_pin>7?((gpio_value&0x80)==0?'0':'1'):'X');
		printf("Write GPIO set %d to Low:\n", i);
#ifndef __linux__
    system ("pause");
#else
    printf("Press Enter key to continue...\n");  
    fgetc(stdin); 
#endif
			ret = PET_GPIO_Write(i, 0);
			if (ret != NOERROR)
				printf(" PET_GPIO_Write(%d) failed %d\n", i, ret);
			else
				printf(" PET_GPIO_Write group %d to 0\n", i);
			printf(" GPIO PINS     : 1 2 3 4 5 6 7 8\n");
			ret = PET_GPIO_Read(i, &gpio_value);
			printf(" GPIO Data     : %c %c %c %c %c %c %c %c\n", 
				gpio_pin>0?((gpio_value&0x01)==0?'0':'1'):'X',
				gpio_pin>1?((gpio_value&0x02)==0?'0':'1'):'X',
				gpio_pin>2?((gpio_value&0x04)==0?'0':'1'):'X',
				gpio_pin>3?((gpio_value&0x08)==0?'0':'1'):'X',
				gpio_pin>4?((gpio_value&0x10)==0?'0':'1'):'X',
				gpio_pin>5?((gpio_value&0x20)==0?'0':'1'):'X',
				gpio_pin>6?((gpio_value&0x40)==0?'0':'1'):'X',
				gpio_pin>7?((gpio_value&0x80)==0?'0':'1'):'X');
		}
	}
	break;
case GPIO_READ:
	printf("GPIO read test start:\n");
	ret = PET_GPIO_TotalSet(&gpio_set);
	if(ret == 0)
		printf(" Number of GPIO Groups: %d\n", gpio_set);
	else
		printf(" Number of GPIO Groups: Not Support\n");
	for(i=1;i<=gpio_set;i++){
		printf("Set %d GPIO info:\n", i);
		ret = PET_GPIO_TotalNumber(i, &gpio_pin);
		if(ret == 0)
			printf(" Number of GPIO Pins in the group: %d\n", gpio_pin);
		else
			printf(" Number of GPIO Pins: Not Support\n");
		ret = PET_GPIO_ReadDirection(i, &gpio_direction);
		if(ret == 0)
			printf(" GPIO Direction: %c %c %c %c %c %c %c %c\n", 
			gpio_pin>0?((gpio_direction&0x01)==0?'O':'I'):'X',
			gpio_pin>1?((gpio_direction&0x02)==0?'O':'I'):'X',
			gpio_pin>2?((gpio_direction&0x04)==0?'O':'I'):'X',
			gpio_pin>3?((gpio_direction&0x08)==0?'O':'I'):'X',
			gpio_pin>4?((gpio_direction&0x10)==0?'O':'I'):'X',
			gpio_pin>5?((gpio_direction&0x20)==0?'O':'I'):'X',
			gpio_pin>6?((gpio_direction&0x40)==0?'O':'I'):'X',
			gpio_pin>7?((gpio_direction&0x80)==0?'O':'I'):'X');
		else
			printf(" GPIO Direction: Not Support\n");
//		ret = PET_GPIO_ReadPinDirection (int gpio_set, int pin_num, unsigned char *io_direction);
		ret = PET_GPIO_Read(i, &gpio_value);
		if(ret == 0)
			printf(" GPIO Data     : %c %c %c %c %c %c %c %c\n", 
			gpio_pin>0?((gpio_value&0x01)==0?'0':'1'):'X',
			gpio_pin>1?((gpio_value&0x02)==0?'0':'1'):'X',
			gpio_pin>2?((gpio_value&0x04)==0?'0':'1'):'X',
			gpio_pin>3?((gpio_value&0x08)==0?'0':'1'):'X',
			gpio_pin>4?((gpio_value&0x10)==0?'0':'1'):'X',
			gpio_pin>5?((gpio_value&0x20)==0?'0':'1'):'X',
			gpio_pin>6?((gpio_value&0x40)==0?'0':'1'):'X',
			gpio_pin>7?((gpio_value&0x80)==0?'0':'1'):'X');
		else
			printf(" GPIO Data     : Not Support\n");
//		ret = PET_GPIO_ReadPin (int gpio_set, int pin_num, unsigned char *value);
	}
break;
case TEST_GPIO_INPUT:

	printf ("GPIO1 PIN 1~8 is set GPI (high) \n");
	printf ("Press put jumper to test... from PIN 1 ~ 8\n");
	printf ("Press PIN 8 put jumper to low will exit test.\n");

	PET_GPIO_SetDirection (1, 0xFF); 

	i=1;
	while(1)
	{
		for (i = 1; i <=8; i++)
		{
			PET_GPIO_ReadPin (1, i, &gpio_value);
			if (gpio_value == 0)
			{
				if (i == 8)
					goto ENDGPIOTEST;
				else
				{
					printf("GPI1 PIN %d input pull low detect!\n", i);
				}
			}
		}
	}
ENDGPIOTEST:
	printf ("GPI1 test finish\n");

break;

case TEST_GPIO_INPUT2:

	printf ("GPIO2 PIN 1~8 is set GPI (high) \n");
	printf ("Press put jumper to test... from PIN 1 ~ 8\n");
	printf ("Press PIN 8 put jumper to low will exit test.\n");

	PET_GPIO_SetDirection (2, 0xFF); 

	i=1;
	while(1)
	{
		for (i = 1; i <=8; i++)
		{
			PET_GPIO_ReadPin (2, i, &gpio_value);
			if (gpio_value == 0)
			{
				if (i == 8)
					goto ENDGPIOTEST2;
				else
				{
					printf("GPI2 PIN %d input pull low detect!\n", i);
				}
			}
		}
	}
ENDGPIOTEST2:
	printf ("GPI2 test finish\n");

break;
#ifdef SMBUS_EEPROM_TEST
case SMBUS_EEPROM_TEST:
	smbus_value = 0x00;
	printf ("\n==== Test PET_SMBus_Read_EEPROM ====\n");
	printf ("   00 01 02 03 04 05 06 07 08 09 0a 0b 0c 0d 0e 0f\n");

	for (i = 0; i <= 0xF; i++)
	{
		printf ("%02X ", (i << 4));
		for (j = 0; j <= 0x0F; j++)
		{
			error_code = PET_SMBus_Read_EEPROM(slave_addr, offset, 0x10, value);
			if (error_code != NOERROR)
			{
				printf ("SMbus Slave addr 0x%02X no device, error code %d\n", slave_addr, error_code);
				continue;
			}
			printf ("%02X ", value[j]);
			offset++;
		}
		printf ("\n");
	}
	printf ("\n");
break;
#endif
case SMBUS_TEST:
	printf("-----------------------Read-----------------------\n");
	do{
		printf("Please input target smbus device address(8 bits):\n");
	}while(scanf("%hhx", &slaveAddress)!=1);
	do{
		printf("Please input read data offset:\n");
	}while(scanf("%x", &offset)!=1);
		smbus_value=0;
		error_code = PET_SMBus_ByteData (SM_READ, slaveAddress, offset, &smbus_value);
		if(error_code==0)
			printf("smbus device %#x, offset %#x, Read data %#x PASS\n", slaveAddress, offset, smbus_value);
		else
			printf("smbus device %#x, offset %#x, Read data  Error(%#x), val=%#x\n", slaveAddress, offset, error_code, smbus_value);
break;

case SMBUS_SCAN:
	slave_addr = 0x00;
	smbus_value = 0x00;
	offset=0;

	for (i = 0; i <= 0xF; i++)
	{
		for (j = 0; j <= 0x0F; j++)
		{
			error_code = PET_SMBus_ByteData (SM_READ, slave_addr, offset, &smbus_value);
			if (error_code == NOERROR)
				printf ("\nslave_addr %02X read %02X = %02X\n", slave_addr, offset, smbus_value);
			else
				printf("%x%x ", i, j);
			slave_addr++;
		}
		printf ("\n");
	}
	printf ("\n");
SMB_FINISH:
	printf ("\n");
break;

case BLC_TEST:
	
	error_code = PET_BLC_Available(0);
	if (error_code == NOERROR)
		printf ("Blacklight control is available.\n");
	else if (error_code == NOT_SUPPORT)
		printf ("Blacklight no support.\n");
	else
        printf ("Blacklight control error, error number %d\n", error_code);

	error_code = PET_BLC_Set_Brightness (0, blc_ratio);
	if (error_code == 0)
		printf ("Blacklight set %d%% successful.\n", blc_ratio);
	else if (error_code == NOT_SUPPORT)
		printf ("Blacklight setting no support.\n");
	else
        printf ("Blacklight setting error, error number %d\n", error_code);

break;

case BEEP_TEST:

	printf ("Beep alarm......");
		          // freq, sec
	PET_HWM_SetBeep (1000, 5); 
	printf ("END.\n");

break;

case NOTE_TEST:

	PET_HWM_SetMetronome (80);
	
	printf ("Play a song......");
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 2);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 2);

	PET_HWM_PlayNote (0, 1, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 2);

	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 2);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 2);

	PET_HWM_PlayNote (0, 1, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 4);

	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 4, 0, 2);

	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 2);

	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 2);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 2);

	PET_HWM_PlayNote (0, 1, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 1, 0, 4);
	
	printf ("finish!!\n");
	
break;

#ifdef EC_IIC_RWC
case EC_IIC_RWC:
	if(argv[2] != NULL && argv[2][0]=='w')
		testeciic(2, argv[1], 0);
	else if(argv[2] != NULL && argv[2][0]=='t'){
		i=0;
		while(1){
			printf("run %d times\n", i);
			if(testeciic(2, argv[1], i%256)==0){
				if(testeciic(3, argv[1], 0)!=0)
					break;
			}else
				break;
			i++;
		}
	}else
		testeciic(1, argv[1], 0) ;
break;
#endif
	default:
	 error_code = -1;
}

	PET_API_Uninit ();
#ifndef __linux__
    system ("pause");
#endif
    return error_code;
}

